#include <dialog.h>
#include "tlmpdia.h"
#include "tlmpdia.m"

struct UITHREAD_INFO{
	PRIVATE_MESSAGE *msg;
	int no;
	int &count;
	_F_uithread *c;
	UITHREAD_INFO(
		PRIVATE_MESSAGE &_msg,
		int &_count,
		int _no,
		_F_uithread &_c)
		: count(_count)
	{
		msg = &_msg;
		no = _no;
		c = &_c;
	}
};

static void start_thread(void *data)
{
	UITHREAD_INFO *info = (UITHREAD_INFO*)data;
	switch (info->no){
	case 0:
		info->c->thread1();
		break;
	case 1:
		info->c->thread2();
		break;
	case 2:
		info->c->thread3();
		break;
	case 3:
		info->c->thread4();
		break;
	case 4:
		info->c->thread5();
		break;
	}
	info->count++;
	dialog_sendmessage (*info->msg);
	delete info;
}
void _F_uithread::thread3()
{
}
void _F_uithread::thread4()
{
}
void _F_uithread::thread5()
{
}

void uithread (_F_uithread &c)
{
	if (dialog_mode != DIALOG_GUI){
		xconf_error (MSG_U(E_ONLYGUIMODE
			,"TLMP component uithread only works in GUI mode.\n"
			 "Maybe the GUI is not initialised yet."));
	}else{
		int count = 0;
		PRIVATE_MESSAGE msg;
		uithread (start_thread,new UITHREAD_INFO(msg,count,0,c));
		uithread (start_thread,new UITHREAD_INFO(msg,count,1,c));
	   	uithread (start_thread,new UITHREAD_INFO(msg,count,2,c));
	   	uithread (start_thread,new UITHREAD_INFO(msg,count,3,c));
	   	uithread (start_thread,new UITHREAD_INFO(msg,count,4,c));
		while (count < 5){
			dialog_waitformessage (msg);
		}
	}
}

